//+------------------------------------------------------------------+
//|                                                    uni_cross_EA  |
//|                                                    maximo 2013   |
//+------------------------------------------------------------------+

#property copyright ""
#property link      ""

string        EA_name         = "uni_cross_EA";
string        EA_vers         = " v1.0";
extern bool   AllowTrading    = True,
              ArrowsOn        = True,
              AlertsOn        = False,
              EmailOn         = False;
extern double Lots            = 0.01;
double        openlots;
double        openpips;
extern int    StopLoss        = 0;
extern int    TakeProfit      = 0;
extern int    T3Period        = 30;
extern int    T3Price         = PRICE_CLOSE;
extern double b               = 0.618;
extern int    Snake_Period    = 10;
extern int    BarCloses       = 0; // 0=live bar, 1=bar 1st close, 2=bar 2nd candle etc.
extern color  ArrowUP         = Aqua;
extern color  ArrowDOWN       = Magenta;
extern string NameFileSound   = "alert.wav";
extern int    MagicNumber     = 54321;
extern int    BreakEvenAtPips = 0; 
extern bool   TrailAtProfit   = False;
extern int    TrailingStopPips= 0;
extern int    TrailingStep    = 2;
double        SignalBar;
double        PipValue;
int           BarCount;
int           period;
int           orders;
int           error;
int           sells;
int           buys;
string        msg;
bool          b1;
bool          s1;

int init()
{
   if (Digits <= 3) PipValue = 0.01;
   else PipValue = 0.0001;
   return(0);
}

int deinit() { Comment(""); return(0); }

int start()
{
   CountOrders();
   if (buys+sells==0) { b1=false; s1=false; }

   double T30     = iCustom(Symbol(),0,"T3_clean",T3Period,T3Price, b, 0, BarCloses);       
   double T31     = iCustom(Symbol(),0,"T3_clean",T3Period,T3Price, b, 0, BarCloses+1); //+1
   double snake0  = iCustom(Symbol(),0,"Snake"   ,Snake_Period    ,     0, BarCloses);
   double snake1  = iCustom(Symbol(),0,"Snake"   ,Snake_Period    ,     0, BarCloses+1); //+1               

   if (Bars > SignalBar) // limit 1 signal per bar
   {            
      if((snake0 >= T30 && snake1 <= T31) || sells > 0) b1=true;
      if((snake0 >= T30 && snake1 <= T31) || (snake0 > T30 && snake1 > T31 && b1))
      {  
         if (AlertsOn && Bars > SignalBar) Alert(Symbol() + " " + EA_name + " BUY ",Period()); SignalBar = Bars;
         if (sells > 0) Close_All();
         if (buys < 1) Trade_BUY(Lots);
      } 
      if((snake0 <= T30 && snake1 >= T31) || buys > 0) s1=true;
      if((snake0 <= T30 && snake1 >= T31) || (snake0 < T30 && snake1 < T31 && s1))
      {
         if (AlertsOn && Bars > SignalBar) Alert(Symbol() + " " + EA_name + " BUY ",Period());  SignalBar = Bars;
         if (buys > 0) Close_All();
         if (sells < 1) Trade_SELL(Lots);
      }
   }

   ManageTrade();
   Display_stats();       

   return(0);
}

void Trade_BUY(double lotsize)
{
   if (AllowTrading)
   {
      if (!Trade_Check()) return;
      int ticket=-1;
      ticket = OrderSend(Symbol(), OP_BUY, lotsize, Ask, 5, 0, 0, EA_name + EA_vers, MagicNumber, 0, Blue);
      if (ticket < 0) { error = GetLastError(); Print("Error opening Order " + error); PlaySound("hal_sorry.wav"); }
      if (OrderSelect(ticket, SELECT_BY_TICKET) != False)
      {
         double SL, TP;
         if (StopLoss > 0 ) SL = OrderOpenPrice() - StopLoss * PipValue;
         if (TakeProfit > 0) TP = OrderOpenPrice() + TakeProfit * PipValue;
         if (SL + TP > 0)
         {
            int ticketmodify = OrderModify(ticket, OrderOpenPrice(), SL, TP, 0, Blue);
            if (!ticketmodify) Print("Modify Buy Error ", GetLastError(),"  SL=",SL,"  TP=",TP);
         }
      }
   }
   if (EmailOn) SendMail(EA_name + " Alert!",Symbol() + " BUY - " + EA_name);
   if (ArrowsOn)
   {
      ObjectCreate( EA_name + "_Buy_" + Time[0], OBJ_ARROW, 0, TimeCurrent(), Bid);
      ObjectSet( EA_name + "_Buy_" + Time[0], OBJPROP_ARROWCODE, 228);
      ObjectSet( EA_name + "_Buy_" + Time[0], OBJPROP_COLOR, ArrowUP);
   }
   Sleep(3300);
}

void Trade_SELL(double lotsize)
{
   if (AllowTrading)
   {
      if (!Trade_Check()) return;
      int ticket=-1;
      ticket = OrderSend(Symbol(), OP_SELL, lotsize, Bid, 5, 0, 0, EA_name + EA_vers, MagicNumber, 0, Red);
      if (ticket < 0) { error = GetLastError(); Print("Error opening Order " + error); PlaySound("hal_sorry.wav"); }
      if (OrderSelect(ticket, SELECT_BY_TICKET) != False)
      {
         double SL, TP;
         if (StopLoss > 0 ) SL = OrderOpenPrice() + StopLoss * PipValue;
         if (TakeProfit > 0) TP = OrderOpenPrice() - TakeProfit * PipValue;
         if (SL + TP > 0)
         {
            int ticketmodify = OrderModify(ticket, OrderOpenPrice(), SL, TP, 0, Red);
            if (!ticketmodify) Print("Modify Sell Error ", GetLastError(),"  SL=",SL,"  TP=",TP);
         }
      }
   }
   if (EmailOn) SendMail(EA_name + " Alert!",Symbol() + " SELL - " + EA_name);
   if (AlertsOn) Alert(Symbol() + " " + EA_name + " SELL");
   if (ArrowsOn)
   {
      ObjectCreate( EA_name + "_Sell_" + Time[0], OBJ_ARROW, 0, TimeCurrent(), Ask);
      ObjectSet( EA_name + "_Sell_" + Time[0], OBJPROP_ARROWCODE, 230);
      ObjectSet( EA_name + "_Sell_" + Time[0], OBJPROP_COLOR, ArrowDOWN); 
   }
   Sleep(3300);
}

void CountOrders()
{
   buys = 0; sells = 0; openlots = 0.0; openpips = 0.0;
   int ord_total = OrdersTotal();
   for (int pos = 0; pos < ord_total; pos++)
   {
      OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
         if (OrderType() == OP_BUY) { buys++; openpips = (Bid - OrderOpenPrice()) / PipValue; }
         if (OrderType() == OP_SELL) { sells++; openpips = (OrderOpenPrice() - Ask) / PipValue; }
         openlots = OrderLots();
      }
   }
}

bool Trade_Check()
{
   for (double cb=0; IsTradeContextBusy() && cb < 100; cb++) Sleep(100); //Wait upto 10 seconds
   if (cb > 0) Print("Trade context was busy ", DoubleToStr(100 * cb / 1000, 2)," seconds");
   if (!IsTradeAllowed()) return(0);
   else return(1);
}

void Close_All()
{
   int ticket=-1;
   int retries;
   for (int pos = OrdersTotal(); pos >= 0; pos--)
   {
      OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
         retries = 0;
         if (OrderType() == OP_BUY )
         {
            ticket = OrderClose(OrderTicket(), OrderLots(), Bid, 5, Aqua);
            if (ticket < 0)
            {
               error = GetLastError(); Print("Error Closing Order " + error);
               while (ticket < 0 && retries < 10)
               {
                  Sleep(51000);
                  ticket = OrderClose(OrderTicket(), OrderLots(), Bid, 5, Aqua);
                  retries++;
               }
            }
            Sleep(500);
         }
         if (OrderType() == OP_SELL)
         {
            ticket = OrderClose(OrderTicket(), OrderLots(), Ask, 5, Magenta);
            if (ticket < 0)
            {
               error = GetLastError(); Print("Error Closing Order " + error);
               while (ticket < 0 && retries < 10)
               {
                  Sleep(51000);
                  ticket = OrderClose(OrderTicket(), OrderLots(), Ask, 5, Magenta);     
                  retries++;
               }               
            }
            Sleep(500);
         }
      }
   }   
}

void ManageTrade() {
   int TicketModify = -1;
   double stoploss;
   for (int pos = 0; pos < OrdersTotal(); pos++)
   {
      if (OrderSelect(pos, SELECT_BY_POS) == TRUE && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol())
      {
         if (OrderType() == OP_BUY)
         {
            if (BreakEvenAtPips > 0)
              if (Bid - OrderOpenPrice() >= BreakEvenAtPips * PipValue && OrderStopLoss() < OrderOpenPrice()) 
                  TicketModify = OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), OrderExpiration(),0);
                  if (!TicketModify) Print("Modify Buy Breakeven Error ", GetLastError(),"  lots=",OrderLots());
            if (TrailingStopPips > 0)
            {
               if (TrailAtProfit && Bid <= OrderOpenPrice() + TrailingStopPips * PipValue) return;
               if (Bid > OrderStopLoss() + TrailingStopPips * PipValue + (TrailingStep * PipValue))
               {
                  stoploss = Bid - TrailingStopPips * PipValue;
                  TicketModify = OrderModify(OrderTicket(), OrderOpenPrice(), stoploss, OrderTakeProfit(), 0);
                  if (!TicketModify) Print("Modify Buy Trailing Stop Error ", GetLastError());
               }
            }
         }

         if (OrderType() == OP_SELL)
         {
            if (BreakEvenAtPips > 0)
              if (OrderOpenPrice() - Ask >= BreakEvenAtPips * PipValue && OrderStopLoss() > OrderOpenPrice())
                  TicketModify = OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), OrderExpiration(),0);
                  if (!TicketModify) Print("Modify Sell Breakeven Error ", GetLastError(),"  lots=",OrderLots()); 
            if (TrailingStopPips > 0)
            {
               if (TrailAtProfit && Ask >= OrderOpenPrice() - TrailingStopPips * PipValue) return;
               if (Ask < OrderStopLoss() - TrailingStopPips * PipValue - (TrailingStep * PipValue))
               {
                 stoploss = Ask + TrailingStopPips * PipValue;
                 TicketModify = OrderModify(OrderTicket(), OrderOpenPrice(), stoploss, OrderTakeProfit(), 0);
                 if (!TicketModify) Print("Modify Sell Trailing Stop Error ", GetLastError());
               }
            }
         }
      }
   }
}

void Display_stats()
{
     double Snake    = iCustom(Symbol(),0,"Snake"   ,Snake_Period, 0, 0);
     double T3_clean = iCustom(Symbol(),0,"T3_clean",T3Period    , T3Price,b,0,0);   

     msg = "";
     msg = msg
       + "\n " + EA_name + EA_vers
       + "\n _______________\n"
       + "\n Server Time: " + TimeToStr(TimeCurrent(), TIME_MINUTES)
       + "\n Spread: " + DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD) / (PipValue / Point), 1)
       + "\n"
       + "\n Lot Size:  " + DoubleToStr(Lots,2)
       + "\n Open Lots " + DoubleToStr(openlots,2)
       + "\n Open Pips " + DoubleToStr(openpips,1)
       + "\n"
       //+ "\n Snake:    " + DoubleToStr(Snake,Digits)
       //+ "\n T3_clean: " + DoubleToStr(T3_clean,Digits)
       + "\n";
     Comment(msg);
}
   